<?php
namespace Teknisa\COZ\Controllers;

use Zeedhi\Framework\Report\ReportService;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO;

class Coz10600 extends \Zeedhi\Framework\Controller\Report {

    protected $requisicaoPlanejamentoProducaoService;
    protected $distribuicaoProducaoController;
    protected $coz10600Service;
    protected $listaController;
    protected $entityManager;
    protected $reportName;
    protected $nrlistaetiq;
    protected $birtStrategy;

    public function __construct(ReportService $reportService, $entityManager, $requisicaoPlanejamentoProducaoService, $distribuicaoProducaoController, $coz10600Service, $listaController, $birtStrategy) {
        $this->requisicaoPlanejamentoProducaoService = $requisicaoPlanejamentoProducaoService;
        $this->distribuicaoProducaoController = $distribuicaoProducaoController;
        $this->coz10600Service = $coz10600Service;
        $this->listaController = $listaController;
        $this->entityManager = $entityManager;
        $this->birtStrategy  = $birtStrategy;
        
        parent::__construct($reportService);
    }

    protected $reportMapping = array (
    'dis10600' => 
        array (
            'strategy' => 'BIRT',
            'parameterMapping' => 
            array (
                'NRORG' => 'P_NRORG',
                'CDCENTRAL' => 'P_CDCENTRAL',
                'NRLISTASERV' => 'P_NRLISTASERV',
                'LISTAPRODUTO' => 'P_LISTAPROD',
                'DTINICIAL' => 'P_DTCONSUMOINI',
                'DTFINAL' => 'P_DTCONSUMOFIN',
                'NRDISTPROD' => 'P_NRDISTPROD',
                'CDPICTPROD'=> 'P_CDPICTPROD'
            )
        ),
    'dis10601' => 
        array (
            'strategy' => 'BIRT',
            'parameterMapping' => 
            array (
                'NRORG' => 'P_NRORG',
                'CDCENTRAL' => 'P_CDCENTRAL',
                'NRLISTASERV' => 'P_NRLISTASERV',
                'LISTAPRODUTO' => 'P_LISTAPROD',
                'DTINICIAL' => 'P_DTCONSUMOINI',
                'DTFINAL' => 'P_DTCONSUMOFIN',
                'NRDISTPROD' => 'P_NRDISTPROD',
                'CDPICTPROD'=> 'P_CDPICTPROD'
            )
        ),
    'dis10602' => 
        array (
            'strategy' => 'BIRT',
            'parameterMapping' => 
            array (
                'NRLISTASERV' => 'P_NRLISTASERV',
                'NRLISTAETIQ' => 'P_NRLISTAETIQ',
                'CDCENTRAL' => 'P_CDCENTRAL',
                'LISTAPRODUTO' => 'P_LISTAPROD',
                'DTINICIAL' => 'P_DTCONSUMOINI',
                'DTFINAL' => 'P_DTCONSUMOFIN',
                'NRDISTPROD' => 'P_NRDISTPROD',
                'NRORG' => 'P_NRORG'
            )
        ),
    'dis10603' =>
        array (
            'strategy' => 'BIRT',
            'parameterMapping' =>
            array (
                'NRORG' => 'P_NRORG',
                'CDCENTRAL' => 'P_CDCENTRAL',
                'NRLISTASERV' => 'P_NRLISTASERV',
                'LISTAPRODUTO' => 'P_LISTAPROD',
                'DTINICIAL' => 'P_DTCONSUMOINI',
                'DTFINAL' => 'P_DTCONSUMOFIN',
                'NRDISTPROD' => 'P_NRDISTPROD',
                'CDPICTPROD'=> 'P_CDPICTPROD'
            )
        ),
    'dis10604' =>
        array (
            'strategy' => 'BIRT',
            'parameterMapping' =>
            array (
                'NRORG' => 'P_NRORG',
                'CDCENTRAL' => 'P_CDCENTRAL',
                'NRLISTASERV' => 'P_NRLISTASERV',
                'LISTAPRODUTO' => 'P_LISTAPROD',
                'DTINICIAL' => 'P_DTCONSUMOINI',
                'DTFINAL' => 'P_DTCONSUMOFIN',
                'NRDISTPROD' => 'P_NRDISTPROD',
                'CDPICTPROD'=> 'P_CDPICTPROD'
            )
        ),
    'dis15504' => 
        array (
            'strategy' => 'BIRT',
            'parameterMapping' => 
            array (
                'NRORG' => 'P_NRORG',
                'DTINICIAL' => 'P_DTINI',
                'DTFINAL' => 'P_DTFIN',
                'LISTAPRODUTO' => 'P_LISTAPROD',
                'NRDISTPROD' => 'P_NRDISTPROD',
                'NRLISTASERV' => 'P_NRLISTASERV',
                'CDCENTRAL' => 'P_CDCENTRAL'
            )
        ),
    'dis10605' =>
        array (
            'strategy' => 'BIRT',
            'parameterMapping' =>
                array (
                    'NRLISTASERV' => 'P_NRLISTASERV',
                    'NRLISTAETIQ' => 'P_NRLISTAETIQ',
                    'CDCENTRAL' => 'P_CDCENTRAL',
                    'LISTAPRODUTO' => 'P_LISTAPROD',
                    'DTINICIAL' => 'P_DTCONSUMOINI',
                    'DTFINAL' => 'P_DTCONSUMOFIN',
                    'NRDISTPROD' => 'P_NRDISTPROD',
                    'NRORG' => 'P_NRORG'
                )
        ),
    'dis10606' =>
        array (
            'strategy' => 'BIRT',
            'parameterMapping' =>
                array (
                    'NRLISTASERV' => 'P_NRLISTASERV',
                    'NRLISTAETIQ' => 'P_NRLISTAETIQ',
                    'CDCENTRAL' => 'P_CDCENTRAL',
                    'LISTAPRODUTO' => 'P_LISTAPROD',
                    'DTINICIAL' => 'P_DTCONSUMOINI',
                    'DTFINAL' => 'P_DTCONSUMOFIN',
                    'NRDISTPROD' => 'P_NRDISTPROD',
                    'NRORG' => 'P_NRORG'
                )
        ),
    'dis10607' =>
        array (
            'strategy' => 'BIRT',
            'parameterMapping' =>
                array (
                    'DTINICIAL' => 'P_DTCONSUMOINI',
                    'DTFINAL' => 'P_DTCONSUMOFIN',
                    'NRORG' => 'P_NRORG',
                    'CDCENTRAL' => 'P_CDCENTRAL',
                    'NRDISTPROD' => 'P_NRDISTPROD',
                    'NRLISTASERV' => 'P_NRLISTASERV',
                    'LISTAPRODUTO' => 'P_LISTAPROD'
                )
        )
    );

    public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response) {
        $row = $request->getRow();
        
        $this->birtStrategy->setReportFormat(strtolower($row['QR2TYPE']));

        $listaFilial = $row["LISTAFILIAL"] = $this->coz10600Service->retornaFiliais((array)$row);
        $row["LISTAGRUPSERV"] = $this->coz10600Service->retornaGrupServ((array)$row);
        $row['SERVICOFILIAL'] = $this->coz10600Service->retornaServico((array)$row);
        $listaServico = $row["LISTASERVICO"] = $this->coz10600Service->concatArray($row['SERVICOFILIAL'], 'SERVICO');
        $row["LISTAPRODUTO"] = $this->coz10600Service->retornaProduto((array)$row);
        $this->reportName = $row['CD_REPORT_NAME'];
        $this->nrorg = $row['NRORG'] = $this->coz10600Service->environment->getNrorgTrab();
        $cdcentral = $row['CDCENTRAL'];
        $dtinicial = $row['DTINICIAL'];
        $dtfinal = $row['DTFINAL'];
        $listaproduto = $row['LISTAPRODUTO'];
        $row['NRLISTASERV'] =  $this->listaController->geraListaServico($row['LISTASERVICO'], $row['NRORG']);

        if($this->reportName == 'dis10602' or $this->reportName == 'dis10605' or $this->reportName == 'dis10606') {

            $lista = $this->distribuicaoProducaoController->retornaListaEtiquetas($cdcentral, $dtinicial, $dtfinal, $row['NRLISTASERV'] , $listaproduto);
            if ($lista) {
                $this->nrlistaetiq
                    = $this->requisicaoPlanejamentoProducaoService->geraLista(
                    $this->nrorg, $lista, '-'
                );
            } else {
                $this->nrlistaetiq = 'X';
            }

            $row['NRLISTAETIQ'] = $this->nrlistaetiq;

            if ($this->reportName == 'dis10605') {
                $row["LISTASERVICO"] = $listaServico ? $listaServico : 'T';
                $row["LISTAFILIAL"] = $listaFilial ? $listaFilial : 'T';
            }
        }
    }

}